// Generated by CoffeeScript 1.3.3
(function() {
  var __hasProp = {}.hasOwnProperty,
    __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; };

  module.exports = function(BasePlugin) {
    var HighlightjsPlugin, balUtil, highlight, hljs, html5, jsdom;
    html5 = require('html5');
    jsdom = require('jsdom');
    balUtil = require('bal-util');
    hljs = require('highlight.js');
    highlight = function(doc, el, replaceTab, next) {
      var childEl, elIsPreOrCode, language, parentEl, _document, _ref, _ref1, _ref2;
      parentEl = el;
      childEl = el;
      language = null;
      elIsPreOrCode = (_ref = el.tagName.toLowerCase()) === 'pre' || _ref === 'code';
      if (el.hasChildNodes() && el.childNodes[0].tagName && ((_ref1 = el.childNodes[0].tagName.toLowerCase()) === 'pre' || _ref1 === 'code')) {
        childEl = el.childNodes[0];
      } else if (el.parentNode && el.parentNode.tagName && ((_ref2 = el.parentNode.tagName.toLowerCase()) === 'pre' || _ref2 === 'code')) {
        parentEl = el.parentNode;
      }
      if (/highlighted/.test(parentEl.className)) {
        return next();
      }
      if (childEl.className) {
        childEl.className = childEl.className.replace(/(\s*)lang-(\S+)(\s*)/, "$1language-$2$3");
      }
      if (parentEl.className) {
        parentEl.className = parentEl.className.replace(/(\s*)lang-(\S+)(\s*)/, "$1language-$2$3");
      }
      if (el.className) {
        el.className = el.className.replace(/(\s*)lang-(\S+)(\s*)/, "$1language-$2$3");
      }
      language = childEl.getAttribute('lang') || parentEl.getAttribute('lang') || el.getAttribute('lang');
      childEl.removeAttribute('lang');
      parentEl.removeAttribute('lang');
      el.removeAttribute('lang');
      if (language) {
        language = language.replace(/^\s+|\s+$/g, '');
        if (hljs.LANGUAGES[language]) {
          if (elIsPreOrCode) {
            if (childEl.className) {
              childEl.className += " language-" + language;
            } else {
              childEl.className = "language-" + language;
            }
          } else {
            if (el.className) {
              el.className += " language-" + language;
            } else {
              el.className = "language-" + language;
            }
          }
        }
      }
      _document = global.document;
      global.document = doc;
      hljs.highlightBlock(elIsPreOrCode ? childEl : el, replaceTab);
      childEl.removeAttribute('lang');
      parentEl.removeAttribute('lang');
      el.removeAttribute('lang');
      global.document = _document;
      if (parentEl.className) {
        parentEl.className += " highlighted";
      } else {
        parentEl.className = "highlighted";
      }
      return next();
    };
    return HighlightjsPlugin = (function(_super) {

      __extends(HighlightjsPlugin, _super);

      function HighlightjsPlugin() {
        return HighlightjsPlugin.__super__.constructor.apply(this, arguments);
      }

      HighlightjsPlugin.prototype.name = 'highlightjs';

      HighlightjsPlugin.prototype.config = {
        replaceTab: null
      };

      HighlightjsPlugin.prototype.renderDocument = function(opts, next) {
        var doc, el, element, extension, file, replaceTab, tasks, _i, _len;
        extension = opts.extension, file = opts.file;
        replaceTab = this.config.replaceTab;
        if (file.type === 'document' && extension === 'html') {
          doc = jsdom.jsdom(opts.content, null, {
            parser: html5,
            features: {
              QuerySelector: true,
              MutationEvents: false
            }
          });
          el = doc.querySelectorAll('code pre, pre code, .highlight');
          if (el.length === 0) {
            return next();
          }
          tasks = new balUtil.Group(function(err) {
            if (err) {
              return next(err);
            }
            opts.content = doc.innerHTML;
            return next();
          });
          tasks.total = el.length;
          for (_i = 0, _len = el.length; _i < _len; _i++) {
            element = el[_i];
            highlight(doc, element, replaceTab, tasks.completer());
          }
          return true;
        } else {
          return next();
        }
      };

      return HighlightjsPlugin;

    })(BasePlugin);
  };

}).call(this);
